# For NUCLEO-F030R8
import startup
import stm32f030x8
import systick, uart, pwm, gpio, sys, spi

#proc printf(formatstr: cstring){.header: "<stdio.h>", importc: "printf", varargs.}
proc xprintf(formatstr: cstring){.header: "xprintf.h", importc: "xprintf", varargs,used.}

proc IO_Test(spi:auto){.used.} =
    var x = 0
    var sdata :uint8 = 0
    while true:
        # Core register viewing
        xprintf("\n%04d",x)
        xprintf("\nSPI.CR1 = %08X(%X)" ,SPI1.CR1,cast[int](SPI1.CR1.addr) )
        xprintf("\nSPI.CR2 = %08X(%X)" ,SPI1.CR2,cast[int](SPI1.CR2.addr) )
        xprintf("\nRCC.AHBENR  = %08X" ,RCC.AHBENR)
        xprintf("\nRCC.APB1ENR = %08X" ,RCC.APB1ENR)
        xprintf("\nRCC.APB2ENR = %08X" ,RCC.APB2ENR)
        xprintf("\nGPIOA.MODER = %08X" ,GPIOA.MODER)
        xprintf("\nGPIOA.AFR[0]= %08X" ,GPIOA.AFR[0])
        xprintf("\nGPIOA.AFR[1]= %08X" ,GPIOA.AFR[1])
        xprintf("\nGPIOB.MODER = %08X" ,GPIOB.MODER)
        xprintf("\nGPIOB.AFR[0]= %08X" ,GPIOB.AFR[0])
        xprintf("\nGPIOB.AFR[1]= %08X" ,GPIOB.AFR[1])
        xprintf("\n")
        inc(x)
        setTickCounter(200)
        while getTickCounter() > 0: # wait 10msec
            # SPI loop back test
            cs_on()
            var n = spi.send(sdata)
            n = spi.send(n)
            n = spi.send(n)
            n = spi.send(n)
            cs_off()
            if sdata != n:
                xprintf("\nSPI data EEROR!")
                while true:
                    discard
            inc(sdata)


block: # main function
    initSysClock48mhz()
    initGPIO()
    # Start systick timer and interrupt
    discard SysTick_Config(SYSTEM_CLOCK div 1000) # 1msec (1000Hz)
    initSerial(USART2)
    initSPI(SPI1)
    spiEnable()
    initPwm()
    pwm_period_timer_start()

    # PWM tset  Duty setting
    pwm_dutyR_hi( 512)
    pwm_dutyL_hi( 512 shr 1)
    #
    pwm_dutyR_low(512 shr 2)
    pwm_dutyL_low(512 shr 3)

    IO_Test(SPI1)

